



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Maven入门指南（一）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Maven入门指南（一）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-04 23:04:51 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>Maven介绍：</strong></p>
<p>Maven是一个强大的Java项目构建工具。</p>
<p><strong>什么是构建工具？</strong></p>
<p>构建工具是将软件项目构建相关的过程自动化的工具。构建一个软件项目通常包含以下一个或多个过程：</p>
<ul><li>生成源码（如果项目使用自动生成源码）；</li>
<li>从源码生成项目文档；</li>
<li>编译源码；</li>
<li>将编译后的代码打包成JAR文件或者ZIP文件；</li>
<li>将打包好的代码安装到服务器、仓库或者其它的地方；</li></ul>
<p>有些项目可能需要更多的过程才能完成构建，这些过程一般也可以整合到构建工具中，因此它们也可以实现自动化。</p>
<p>自动化构建过程的好处是将手动构建过程中犯错的风险降到最低。而且，自动构建工具通常要比手动执行同样的构建过程要快。</p>
<p><strong>安装Maven</strong></p>
<p>安装Maven，访问<a href="http://maven.apache.org/download.cgi" rel="external nofollow noreferrer">Maven下载页</a>，然后按照安装指南的步骤即可。总结一下，你需要做：<br />1. 下载并解压Maven；<br />2. 将环境变量M2_HOME设置为解压后的目录；<br />3. 将M2环境变量设置为M2_HOME/bin（在Windows上是%M2_HOME%/bin，在Unix上是${M2_HOME}/bin）；<br />4. 将M2添加到PATH环境变量中（Windows上是%M2%，Unix上是${M2}）；<br />5. 打开终端输入`mvn`（不带引号），然后回车；</p>
<p>输入&lsquo;mvn&rsquo;命令后，终端上回显示错误信息。不要担心这个错误。因为你没有给Maven传入pom文件，因此出现该错误信息是意料之中的。显示Maven错误信息说明Maven已经安装好了。</p>
<p>注意：Maven运行需要Java环境，因此也需要安装Java，Java版本1.5及以上；</p>
<p><strong>maven的JDK版本依赖</strong></p>
<table>
<thead>
<tr>
<td>
<p><strong>项目</strong></p>
</td>
<td>
<p><strong>要求</strong></p>
</td>
</tr>
</thead>
<tbody>
<tr>
<td>
<p>JDK</p>
</td>
<td>
<p>Maven 3.3&nbsp;要求&nbsp;JDK 1.7&nbsp;或以上<br />Maven 3.2&nbsp;要求&nbsp;JDK 1.6&nbsp;或以上<br />Maven 3.1&nbsp;要求&nbsp;JDK 1.5&nbsp;或以上</p>
</td>
</tr>
</tbody>
</table>
<p><strong>Maven概览-核心概念</strong></p>
<p>Maven的中心思想是POM文件（项目对象模型）。POM文件是以XML文件的形式表述项目的资源，如源码、测试代码、依赖（用到的外部Jar包）等。POM文件应该位于项目的根目录下。</p>
<p>下图说明了Maven是如何使用POM文件的，以及POM文件的主要组成部分：</p>
<p><img referrerpolicy="no-referrer"src="http://ifeve.com/wp-content/uploads/2014/06/maven-overview-1.png" /></p>
<p>这些概念先简单地解释一下，更多的细节放在本教程的具体小节中。</p>
<p><strong>POM文件</strong></p>
<p>当你执行一条Maven命令的时候，你会传入一个pom文件。Maven会在该pom文件描述的资源上执行该命令。</p>
<p><strong>构建生命周期、阶段和目标</strong></p>
<p>Maven的构建过程被分解为构建生命周期、阶段和目标。一个构建周期由一系列的构建阶段组成，每一个构建阶段由一系列的目标组成。当你运行Maven的时候，你会传入一条命令。这条命令就是构建生命周期、阶段或目标的名字。如果执行一个生命周期，该生命周期内的所有构建阶段都会被执行。如果执行一个构建阶段，在预定义的构建阶段中，所有处于当前构建阶段之前的阶段也都会被执行。</p>
<p><strong>依赖和仓库</strong></p>
<p>Maven执行时，其中一个首要目标就是检查项目的依赖。依赖是你的项目用到的jar文件（java库）。如果在本地仓库中不存在该依赖，则Maven会从中央仓库或远程仓库下载并放到本地仓库。本地仓库只是你电脑硬盘上的一个目录。你可以根据需要制定本地仓库的位置。你也可以指定下载依赖的远程仓库的地址。这些将会在后续的小节中详细介绍。</p>
<p><strong>插件</strong></p>
<p>构建插件可以向构建阶段中增加额外的构建目标。如果Maven标准的构建阶段和目标无法满足项目构建的需求，你可以在POM文件里增加插件。Maven有一些标准的插件供选用，如果需要你可以自己实现插件。</p>
<p><strong>配置文件</strong></p>
<p>配置文件用于以不同的方式构建项目。比如，你可能需要在本地环境构建，用于开发和测试，你也可能需要构建后用于开发环境。这两个构建过程是不同的。在POM文件中增加不同的构建配置，可以启用不同的构建过程。当运行Maven时，可以指定要使用的配置。</p>
<p><strong>Maven与Ant</strong></p>
<p>Ant是Apache另一个流行的构建工具。如果你熟悉Ant，正在学习Maven，你将会注意到两者在方法上的区别。</p>
<p>Ant使用命令式的方式，即你需要在Ant构建文件里指定Ant应该执行的操作。你可以指定低级别的操作，如复制文件、编译代码等。你指定操作，还需要执行这些操作执行的顺序。Ant没有默认的目录结构。</p>
<p>Maven使用声明式的方式，即你需要在POM文件里指定做什么，而不是如何做。POM文件描述项目的资源-而不是如何构建。相比而言，Ant构建文件描述的是如何构建项目。在Maven里，如何构建是在&ldquo;Maven 构建声明周期、阶段和目标&rdquo;中预定义的。</p>
<p><strong>Maven POM 文件</strong></p>
<p>Maven的POM文件是一个xml文件，描述项目用到的资源，包括源代码目录、测试代码目录等的位置，以及项目依赖的外部jar包。</p>
<p>POM文件描述的是构建&ldquo;什么&rdquo;，而不是&ldquo;如何&rdquo;构建。如何构建是取决于Maven的构建阶段和目标。当然，如果需要，你也可以向Maven构建阶段中添加自定义的目标。</p>
<p>每一个项目都有一个POM文件。POM文件即pom.xml，应该放在项目的根目录下。一个项目如果分为多个子项目，一般来讲，父项目有一个POM文件，每一个子项目都有一个POM文件。在这种结构下，既可以一步构建整个项目，也可以各个子项目分开构建。</p>
<p>本文剩下的章节，主要介绍POM文件最重要的部分。POM文件的完整文档，参考[Maven POM Reference](http://maven.apache.org/pom.html)</p>
<p>如下为一个最小化的POM文件示例：</p>
<div>
<pre class="prettyprint linenums">&lt;project xmlns=&rdquo;http://maven.apache.org/POM/4.0.0&Prime;<br />
xmlns:xsi=&rdquo;http://www.w3.org/2001/XMLSchema-instance&rdquo;<br />
xsi:schemaLocation=&rdquo;http://maven.apache.org/POM/4.0.0<br />
http://maven.apache.org/xsd/maven-4.0.0.xsd&rdquo;&gt;<br />
&lt;modelVersion&gt;4.0.0&lt;/modelVersion&gt;

&lt;groupId&gt;com.jenkov&lt;/groupId&gt;<br />
&lt;artifactId&gt;java-web-crawler&lt;/artifactId&gt;<br />
&lt;version&gt;1.0.0&lt;/version&gt;<br />
&lt;/project&gt;
</pre>
</div>
<p>　　</p>
<p>modelVersion*属性表示使用的POM模型的版本。选择和你正在使用的Maven版本一致的版本即可。版本4.0.0适用于Maven 2和3。</p>
<p>*groupId&rdquo;属性是一个组织或者项目（比如开源项目）的唯一ID。大多数情况下，你会使用项目的java包的根名称作为group ID。例如，对于我自己的Java网络爬虫项目，我会使用com.jenkov作为group ID。如果这个项目是一个由很多独立的贡献者组成的开源项目，也许选择与项目相关的名称作为group ID，比选择与我的公司相关的名称名作为group ID要合理地多。因此，选择com.javawebcrawler作为group ID。</p>
<p>groupId不一定非要使用Java的包名，也不一定要使用.分隔符来分隔ID中的词。但是，如果你这么使用，项目将会位于Maven仓库的结构化目录中，该结构化目录与group ID匹配。每一个.是一个目录分隔符，每一个词都表示一个目录。group ID为com.jenkov的项目将位于目录MAVEN_REPO/com/jenkov中。目录路径中的MAVEN_REPO表示Maven仓库的路径。</p>
<p>*artifactId*属性包含你正在构建的项目的名称。以我的Java网络爬虫项目来说，artifact ID为java-web-crawler。artifact ID是Maven仓库中group ID目录下的子目录名。artifact ID也是构建完项目后生成的jar包的文件名的一部分。构建过程的输出，即构建结果，在Maven中成为构件（artifact）。通常它就是一个jar包、war包或者EAR包，蛋它也可以是别的。</p>
<p>*versionId包含项目的版本号。如果你的项目有不同的发行版，比如开源API，对构建过程版本化是很有用的。如果使用版本，项目的用户就可以查看项目的具体版本。版本号是artifact ID目录下的子目录名。版本号也用作构建结果名称的一部分。</p>
<p>上文中的groupId，artifactId和version属性，在项目构建后会生成一个jar文件，位于Maven仓库的如下路径中（目录和文件名）：MAVEN_REPO/com/jenkov/java-web-crawler/1.0.0/java-web-crawler-1.0.0.jar</p>
<p>如果你的项目使用[Maven目录结构](http://tutorials.jenkov.com/maven/maven-tutorial.html#maven-directory-structure)，而且项目没有外部依赖，上面的最简化POM文件就是你构建项目所需的所有配置了。</p>
<p>如果你的项目不遵从标准的目录结构，有外部依赖或者在构建过程中需要加入额外操作，你需要向POM文件中添加更多的配置。更多的配置查阅[Maven POM 参考]</p>
<p>通常，你可以向POM文件中增加各种配置，这些配置告诉Maven如何更好地构建你的项目。查阅Maven的POM参考，了解更多的配置。</p>
<p><strong>父pom</strong></p>
<p>所有的Maven pom文件都继承自一个父pom。如果没有指定父pom，则该pom文件继承自根pom。pom文件的继承关系如下图所示：</p>
<p><img referrerpolicy="no-referrer"src="http://ifeve.com/wp-content/uploads/2014/06/super-pom.png" /></p>
<p>可以让一个pom文件显式地继承另一个pom文件。这样，可以通过修改公共父pom文件的设置来修改所有子pom文件的设置。在pom文件的起始处指定父pom，例如：</p>
<div>
<pre class="prettyprint linenums">&lt;project xmlns=&rdquo;http://maven.apache.org/POM/4.0.0&Prime;<br />
xmlns:xsi=&rdquo;http://www.w3.org/2001/XMLSchema-instance&rdquo;<br />
xsi:schemaLocation=&rdquo;http://maven.apache.org/POM/4.0.0<br />
http://maven.apache.org/xsd/maven-4.0.0.xsd&rdquo;&gt;<br />
&lt;modelVersion&gt;4.0.0&lt;/modelVersion&gt;

&lt;parent&gt;<br />
&lt;groupId&gt;org.codehaus.mojo&lt;/groupId&gt;<br />
&lt;artifactId&gt;my-parent&lt;/artifactId&gt;<br />
&lt;version&gt;2.0&lt;/version&gt;<br />
&lt;relativePath&gt;../my-parent&lt;/relativePath&gt;<br />
&lt;/parent&gt;

&lt;artifactId&gt;my-project&lt;/artifactId&gt;<br />
&hellip;<br />
&lt;/project&gt;
</pre>
</div>
<p>　　</p>
<p>　　子pom文件的设置可以覆盖父pom文件的设置，只需要在子pom文件里指定新的设置即可。<br />　　关于pom文件继承更详细的内容可以参考Maven POM文档。</p>
<p><strong>有效pom</strong></p>
<p>　　考虑到pom文件的继承关系，当Maven执行的时候可能很难确定最终的pom文件的内容。总的pom文件（所有继承关系生效后）被称为有效pom（effective pom）。可以使用以下的命令让Maven打印出当前的有效pom：</p>
<div>
<pre class="prettyprint linenums">　　mvn help:effective-pom　</pre>
</div>
<p>执行以上命令，Maven会将有效pom输出到命令行。</p>
<p><strong>Maven配置文件</strong></p>
<p>　　Maven有两个配置文件。配置文件里的设置，对所有的pom文件都是有效的。比如，你可以配置：</p>
<ul><li><ul><li>　　本地仓库的路径；</li>
<li>　　当前的编译配置选项</li>
<li>　　等等</li></ul></li></ul>
<p>　　配置文件名为settings.xml，两个配置文件分别为：</p>
<p>　　+ Maven安装目录中：$M2_HOME/conf/settings.xml<br />　　+ 用户主目录中：${user.home}/.m2/settings.xml</p>
<p>　　两个配置文件都是可选的。如果两个文件都存在，则用户目录下的配置会覆盖Maven安装目录中的配置。</p>
<p>　　关于Maven配置文件，参考[Maven配置文档](http://maven.apache.org/settings.html)</p>
<p><strong>让Maven跑起来</strong></p>
<p>　　当你安装好了Maven，并且在项目的根目录下创建了POM文件，可以在项目上运行Maven了。</p>
<p>　　运行Maven只需在命令行执行`mvn`命令即可。当执行`mvn`命令时，将构建周期、阶段或目标作为参数传进去，Maven就会执行它们。例如：</p>
<div>
<pre class="prettyprint linenums">　　mvn install</pre>
</div>
<p>　　该命令执行`install`阶段（是默认构建阶段的一部分），编译项目，将打包的JAR文件复制到本地的Maven仓库。事实上，该命令在执行install之前，会执行在构建周期序列中位于install之前的所有阶段。</p>
<p>　　你可以向mvn命令传入多个参数，执行多个构建周期或阶段，如：</p>
<div>
<pre class="prettyprint linenums">　　mvn clean install</pre>
</div>
<p>　　该命令首先执行clean构建周期，删除Maven输出目录中已编译的类文件，然后执行install构建阶段。</p>
<p>　　也可以执行一个Maven目标（构建阶段的一部分），将构建阶段与目标名以冒号(:)相连，作为参数一起传给Maven命令。例如：</p>
<div>
<pre class="prettyprint linenums">　　mvn dependency:copy-dependencies</pre>
</div>
<p>　　该命令执行`dependency`构建阶段中的`copy-dependencies`目标。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9jgx495.html">php使用CI发送qq和163邮件</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e1nek9.html">使用sublime一键格式化XML文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlld2eq.html">iOS 7 tabbar 透明的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ejjdj9.html">在 2016 年学 JavaScript 是一种什么样的体验？</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jlmeeq.html">Jmeter模拟不同带宽</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq142p6q.html">paramiko模块-2</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq142e4q.html">c&plus;&plus; 11 sleep&lpar;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96wyxvq.html">必备技能：分清楚DOM的attribute和property</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdeonjz9.html">JQuery 表格 隔行换色 和鼠标滑过的样式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnywld8.html">UVA 10537 The Toll&excl; Revisited 过路费（最短路，经典变形）</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x12mv8.html">C&plus;&plus;中的static关键字的总结 （转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1vnke9.html">关闭WIN10的UAC&sol;自动更新&sol;杀毒软件（兼容WIN7&sol;8&sol;8&period;1）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlje4469.html">线程：Message和Runnable</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mdj4n8.html">HTTP 返回状态值详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zoeg59.html">InnoSetup 脚本打包及管理员权限设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyvmlmq.html">Pessimistic and Optimistic locking</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jmroeq.html">dubbo学习笔记1</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllx34kq.html">Python基础知识：if语句</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll41w6q.html">python中的import，reload，以及&lowbar;&lowbar;import&lowbar;&lowbar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw0mwk8.html">18&period;1利用socket &period;io 实现 editor间代码的同步</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qdj1dgzq.html">LINQ操作符一：Select</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gp64249.html">实现字符串转化为整数函数atoi&lpar;&rpar;函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ko65mrq.html">安装版的tomcat微信支付时报2字节的UTF-8序列的字节2无效</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7evgg19.html">ElasticSearch0910学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vo4e2q.html">windows下定时任务设置</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1voy64q.html">nodejs基础 -- 回调函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnn6413q.html">TaintDroid下载预编译（五）：TaintDroid（Android）系统编译虚拟机和真机測试</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rnpw3dq.html">eclipse项目配置tomcat后浏览器访问不到项目解决方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/96324xy9.html">while循环中，break&comma;continue&comma;return的差别</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2ke6roq.html">【C&plus;&plus;基础 05】友元函数和友元类</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
